'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
// http://stackoverflow.com/a/6969486/692528
var escapeRegExp = function escapeRegExp(str) {
  return str.replace(/[\-\[\]\/\{\}\(\)\*\+\?\.\\\^\$\|]/g, '\\$&');
};

// http://stackoverflow.com/a/19148116/692528
var chars = '.$[]#/%'.split('');
var charCodes = chars.map(function (c) {
  return '%' + c.charCodeAt(0).toString(16).toUpperCase();
});

var charToCode = {};
var codeToChar = {};
chars.forEach(function (c, i) {
  charToCode[c] = charCodes[i];
  codeToChar[charCodes[i]] = c;
});

var charsRegex = new RegExp('[' + escapeRegExp(chars.join('')) + ']', 'g');
var charCodesRegex = new RegExp(charCodes.join('|'), 'g');

var encode = function encode(str) {
  return str.replace(charsRegex, function (match) {
    return charToCode[match];
  });
};
var decode = function decode(str) {
  return str.replace(charCodesRegex, function (match) {
    return codeToChar[match];
  });
};

exports.encode = encode;
exports.decode = decode;
exports.default = {
  encode: encode,
  decode: decode
};